library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

use work.common_pkg.all;
use work.core_pkg.all;

entity fetch_stage is

	generic	(
			-- active reset value
			RESET_VALUE : std_logic;
			-- active logic value
			LOGIC_ACT : std_logic
			
			);
	port(
		--System inputs
			clk : in std_logic;
			reset : in std_logic;
			s_reset : in std_logic;
		
		--Data inputs
			jump_result : in instruction_addr_t;
			prediction_result : in instruction_addr_t;
			branch_prediction_bit : in std_logic;
			alu_jump_bit : in std_logic;
			int_req : in interrupt_t;
		-- instruction memory program port :D
			new_im_data_in : in std_logic;
			im_addr : in gp_register_t;
			im_data : in gp_register_t;

		--Data outputs
			instruction : out instruction_word_t;
			prog_cnt : out instruction_addr_t;
		-- debug
			led2 : out std_logic
		);
		
end fetch_stage;
